﻿using Newtonsoft.Json;
using System;
using System.Net;
using VCommon.Json;

namespace VCommon.Logging
{
    /// <summary> 避免 EndPoint 序列化异常 </summary>
    public static class VJsonLogSerializer
    {
        private static readonly JsonSerializerSettings Settings = new JsonSerializerSettings
        {
            NullValueHandling = NullValueHandling.Ignore,
            Converters =
            {
                new EndPointConverter()
            }
        };

        public static IVJsonSerializer Instance { get; } = new VJsonSerializer(Settings);

        
    }
}
