﻿using System;
using System.Collections.Generic;

namespace VCommon.VApplication.Authorization
{
    public interface IPermissionManager
    {
        /// <summary> 检查权限代码是否合法 </summary>
        bool ValidPermission(string permission);

        /// <summary> 检查指定的用户是否有权限 </summary>
        bool CheckPermission(Guid tenantId, Guid userId, params string[] hasAnyPermission);

        /// <summary> 获取当前产品完整权限树 </summary>
        IReadOnlyCollection<PermissionNode> GetAllPermissionTree();

        /// <summary> 获取当前可用权限树 </summary>
        IReadOnlyCollection<PermissionNodeOutput> GetPermissionTreeOutput();

        /// <summary> 获取当前用户权限代码集合 </summary>
        string[] GetUserPermissionCodes();
    }
}
