﻿using System.Linq;
using Unity;
using VCommon.Ioc;
using VCommon.VEntity;
using VCommon.VEntityFrameworkCore;

namespace VCommon.VApplication.EntityFrameworkCore
{
    public class VAppEfRepository<TDbContext, TEntity> : VEfRepositoryBase<TDbContext, TEntity> where TEntity : VEntityBase where TDbContext : VAppDbContextBase
    {
        [Dependency]
        public IVSession VSession { get; set; }

        [Dependency]
        public IIocManager IocManager { get; set; }

        public override VEfRepositoryBase<TDbContext, TForkEntity> ForkRepository<TForkEntity>()
        {
            return new VAppEfRepository<TDbContext, TForkEntity> { DbContext = DbContext };
        }

        //TODO: Child Container
        protected override TDbContext ResolveDbContextInstance() => IocManager.Resolve<TDbContext>();

        protected override IQueryable<TEntity> ProcessFilters(IQueryable<TEntity> input)
        {
            //TODO: More filters in VApplication
            //    Org
            //    MustHaveTenant
            //    MayHaveTenant

            return base.ProcessFilters(input);
        }

        public override TEntity Add(TEntity entity)
        {
            //TODO: More filters in VApplication

            if (IsFilterEnabled(VEfDataFilters.MustHaveTenant) && entity is IMustHaveTenant mte) mte.TenantId = VSession.GetTenantId();

            return base.Add(entity);
        }
    }
}
